function wb_stat_str = fun_analysis_sc_whole_brain_stat_str(wb_stat_str, linear_scaling_ratio, radius_scaling_ratio)

wb_stat_str.brain_volume_mm3 = wb_stat_str.brain_volume_mm3 .* linear_scaling_ratio .^ 3;
wb_stat_str.sample_size_mm = wb_stat_str.sample_size_mm .* linear_scaling_ratio;

%% Link
wb_stat_str.link = fun_analysis_sc_structure_fields(wb_stat_str.link, ...
    {'total_length_m', 'total_surf_area_mm2', 'total_volume_mm3', 'length_density_m_mm3', ...
    'volume_density', 'length_90_prctile', 'length_10_prctile'}, ...
    linear_scaling_ratio);
wb_stat_str.link = fun_analysis_sc_structure_fields(wb_stat_str.link, ...
    {'length_density_m_mm3', 'volume_density'}, ...
    linear_scaling_ratio .^ (-3) );
wb_stat_str.link.total_surf_area_mm2 = wb_stat_str.link.total_surf_area_mm2 .* ...
    radius_scaling_ratio;
wb_stat_str.link.total_volume_mm3 = wb_stat_str.link.total_volume_mm3 .* ...
    radius_scaling_ratio^2;
wb_stat_str.link.volume_density = wb_stat_str.link.volume_density .* radius_scaling_ratio ^ 2;
%% Capillary 
wb_stat_str.capillary = fun_analysis_sc_structure_fields(wb_stat_str.capillary, ...
    {'total_length_m', 'total_surf_area_mm2', 'total_volume_mm3', 'length_density_m_mm3', ...
    'volume_density'}, ...
    linear_scaling_ratio);
wb_stat_str.capillary = fun_analysis_sc_structure_fields(wb_stat_str.capillary , ...
    {'length_density_m_mm3', 'volume_density'}, ...
    linear_scaling_ratio .^ (-3) );
wb_stat_str.capillary.volume_density = wb_stat_str.capillary.volume_density .* radius_scaling_ratio ^ 2;
wb_stat_str.capillary.total_volume_mm3 = wb_stat_str.capillary.total_volume_mm3 .* radius_scaling_ratio ^ 2;
wb_stat_str.capillary.total_surf_area_mm2 = wb_stat_str.capillary.total_surf_area_mm2 .* radius_scaling_ratio;
%% Graph
wb_stat_str.graph.largest_cc_total_length = wb_stat_str.graph.largest_cc_total_length .* linear_scaling_ratio;
wb_stat_str.graph.largest_cc_total_capillary_length = wb_stat_str.graph.largest_cc_total_capillary_length .* linear_scaling_ratio;

%% Distributions
wb_stat_str.dist.link_cap_length = fun_analysis_sc_basic_stat_str(...
    wb_stat_str.dist.link_cap_length, linear_scaling_ratio);
wb_stat_str.dist.link_length = fun_analysis_sc_basic_stat_str(...
    wb_stat_str.dist.link_length, linear_scaling_ratio);
wb_stat_str.dist.link_wo_ep_length = fun_analysis_sc_basic_stat_str(...
    wb_stat_str.dist.link_wo_ep_length, linear_scaling_ratio);

wb_stat_str.dist.link_radius = fun_analysis_sc_basic_stat_str(...
    wb_stat_str.dist.link_radius, radius_scaling_ratio);

end