function graph_ind = fun_graph_get_all_voxel_ind(vessel_graph)
% fun_graph_get_all_voxel_ind returns all the voxels indices in the graph
% as a numerical column vector 
% Input:
%   vessel_graph: structure generated by fun_skeleton_to_graph
% Output: 
%   graph_ind: column numerical vector
% 

% graph_ind = cat(1, vessel_graph.node.pos_ind, vessel_graph.link.pos_ind, ...
%     vessel_graph.isoloop.pos_ind, vessel_graph.isopoint.pos_ind);

% For backward compactability
graph_ind = cat(1, vessel_graph.node.pos_ind, vessel_graph.link.pos_ind);
if isfield(vessel_graph, 'isoloop')
   graph_ind = cat(1, graph_ind, vessel_graph.isoloop.pos_ind);
end
if isfield(vessel_graph, 'isopoint')
    graph_ind = cat(1, graph_ind, vessel_graph.isopoint.pos_ind);
end
end