function data_info = fun_graph_get_grid_c_block_info(grid_c, grid_label)
% fun_graph_get_grid_c_block_info generates the combined grid information
% for the block specified by the grid_label
% Input: 
%   grid_c: structure generated by fun_grid_generate_combined_grid
%   grid_label: numerical scalar, label of the block in the grid 
% Output: 
%   data_info: strucutre. 
%
% 
combined_grid_idx_1 = grid_c.bbox_grid_sub_list(grid_label, 1);
combined_grid_idx_2 = grid_c.bbox_grid_sub_list(grid_label, 2);
combined_grid_layer = grid_c.bbox_grid_sub_list(grid_label, 3);
combined_grid_xy_idx = grid_c.bbox_xy_label_mat{combined_grid_layer}(combined_grid_idx_1, combined_grid_idx_2);
% Combined cube information
data_info = struct;
data_info.dataset_name = grid_c.dataset_name;
data_info.stack = grid_c.stack;
data_info.grid_version = grid_c.version;
data_info.combined_grid_xyz_label = grid_label;
data_info.idx_1 = combined_grid_idx_1;
data_info.idx_2 = combined_grid_idx_2;
data_info.layer = combined_grid_layer;
data_info.grid_xy_idx = combined_grid_xy_idx;
data_info.dataset_size = grid_c.data_size;
data_info.bbox_mmxx = grid_c.bbox_xyz_mmxx_pixel{combined_grid_layer}(combined_grid_xy_idx, :);
data_info.bbox_mmll = grid_c.bbox_xyz_mmll_pixel{combined_grid_layer}(combined_grid_xy_idx, :);
data_info.mask_annotated = false;

data_info.sub_grid_version = grid_c.grid_ori.version;
data_info.sub_grid_sub = grid_c.sub_grid_sub{combined_grid_idx_1, combined_grid_idx_2, combined_grid_layer};
data_info.sub_grid_ind = grid_c.sub_grid_ind{combined_grid_idx_1, combined_grid_idx_2, combined_grid_layer};
data_info.sub_grid_global_bbox_mmxx = grid_c.sub_grid_bbox_mmxx{combined_grid_idx_1, combined_grid_idx_2, combined_grid_layer};
data_info.sub_grid_global_bbox_mmll = grid_c.sub_grid_bbox_mmll{combined_grid_idx_1, combined_grid_idx_2, combined_grid_layer};
data_info.sub_grid_valid_ind = grid_c.sub_grid_valid_idx{combined_grid_idx_1, combined_grid_idx_2, combined_grid_layer};
data_info.combined_grid_mmxx_grid = grid_c.bbox_xyz_mmxx_grid{combined_grid_layer}(combined_grid_xy_idx,:);
end